#include "q12.dat"
#include "jfc.c"
int q[17]={0,1,2,3,4,  0,5,2,6,4,  2,7,4, 8,9, 10,11};
// sao <8.0 select 30920stars. U4 minum_mag=4.012
// so too many star be selected, only keep 3000 BSC
// star, up to ~5.5mag
#define  nn   60000
#define  n360 900

double aa[nn],dd[nn];                      // always epoch + proper motion
double rc,dc,a_c,d_c,up_a,dn_a,up_d,dn_d;  // always 2000.0
double epoch;                              // out_put catalog's epoch
double obs_epoch=2000.;                    // only CAT use, n year SM correct
double hs,w_de,xlimag,xxlimag,hs2,cosdc,xm_min,xm_max;
short  ee[nn],mx[nn],my[nn];

short  maga[nn];
char   sigmag[nn],objt[nn],cdf[nn];
double ap1[nn],ap2[nn];
short  api2[5],api1[6];

int    u4index[240][n360],no[nn],nu4,n;     // n==nu4, all select star
FILE   *fp,*fp0,*fp1;

unsigned short map[511][511];
unsigned char cmap[511][511];

char   lab[70],f1[30];                    // gif file name
int    icat=0;

char disfd[4],disxy[9],discen[40],disrd[40];
int  dish4[4];
char disao[6];
// sao
#define nnsao 39020
#define mm       99
int   insao[18][7];              // index   sao.index  ra 60*6  dec 10*18 
int   dasao[nnsao][5];           // datbase sao.base <8.0
char  spsao[140][4];             // spectium
unsigned short saohan[150*16];            // sao.han
char  stenam[88][7];             // ste.nam
int   nsao, isao=0;
double aasao[mm],ddsao[mm];     // always epoch + proper motion
short  mxsao[mm],mysao[mm];
int    a0sao[mm],a4sao[mm];

jfchina1(float x,float y,int *han,int n)
{
  int i,j,k,m,l,ix,iy;  
  ix=nint(jf_xscale*(x-jf_x0)); iy=nint(jf_yscale*(y-jf_y0)); 
  for(m=0;m<n;m++){    l=han[m]*16; 
    for(i=0;i<16;i++){ k=saohan[l++];
      for(j=0;j<16;j++,k/=2)if(k%2==1)jf_ph(ix+16-j,iy-i);
    } ix+=16+jf_gap;
  }
}

main(ac,av)
int ac; char *av[];
{
  double hw_de,hw_al,xmag,xi,xn,xa,xd,z,r,rr;
  float  x,y;
  unsigned char   ch,cc,c1[14],c2[14],dis[70],dis1[60],sc[4];
  int    i,j,k,k1,k2,istar,ix,iy,m,num;
  int    gifno=0;                         // for gif

  pi=4.*atan(1.); cx=pi/12.; cy=pi/180.;

  epoch=2000.0;                          // out_put_catalog  epoch
  xlimag=18.;
  w_de=30.;

  if(ac<3){
    printf("\n\t*********** UCAC4(sao) finding chart ****************\n");
    printf("\n\t                                  jiang 20120926\n");
    printf("\n\t Magnitude range in a single bandpass between V and R");
    printf("\n\t & appending aperture mag. & (APASS) B,V,g,r,i mag.\n");
    printf("\n\t Usage: u4");
    printf("\n\t        u4 -h                                (new mark help)");
    printf("\n\t        u4 ra dec [30]");
    printf("\n\t        u4 ra dec field");
    printf("\n\t        u4 ra dec field CATname [epoch] [obs_epoch] [!]");
    printf("\n\t Note:");    
    printf("\n\t        ra,dec's epoch === 2000.0 (if not, type u4 only)");
    printf("\n\t        epoch: output catalog's epoch, usually = 2000.0");
    printf("\n\t        obs_epoch: calculate Proper Motion correction only");
    printf("\n\t              delta = (obs_epoch-2000.)*each_proper_motion");
    printf("\n\t        ! output all star");
    printf("\n\t        output FITS file, with WCS system.\n\n");
  }
  fp=fopen("/UCAC4/u4index2.unf","rb");
  if(fp==0){
    printf("\n\t u4index2.unf not found!");
    printf("\n\t YOU CAN:   ln -s /CAT_DIR/ucac4/u4b /UCAC4\n");
    printf("\n\t            put u4index2.unf to /UCAC4\n");
    printf("\n\t            surely, Xwin_server in the PATH\n\n");
    exit(0);
  }
  fread(u4index,n360*240,4,fp); fclose(fp);

  if(ac==2){
printf("\n\tYou can read the detail messages in the middle of");
printf("\n\treadme_u4.txt located at /UCAC4 also.\n");
printf("\n\t'col' is index of u4 output file (*.cat)\n");  
printf("\n\tcol  item          explanation             notes");
printf("\n\t-------------------------------------------------");
printf("\n\t 3   magm     UCAC fit model magnitude        (2)");
printf("\n\t 4   maga     UCAC aperture  magnitude        (2)");
printf("\n\t 5   sigmag   error of UCAC magnitude         (3)");
printf("\n\t 6   objt     object type                     (4)");
printf("\n\t 7   cdf      combined double star flag       (5)");
printf("\n\t...");
printf("\n\t29  apasm    B magnitude from APASS          (13)");
printf("\n\t34  apase    error of B magnitude from APASS (14)");
printf("\n\t39  gcflg    Yale SPM g-flag*10  c-flag      (15)\n\n");
    exit(0);
  }

// read sao.all
  fp=fopen("/UCAC4/sao.all","rb");
  if(fp){  isao=1;
     fread(insao,7*18,4,fp);                                     // index
     fread(dasao,nnsao,20,fp);                                   // data_base
     fread(spsao,140,4,fp);                                      // spectium
     fread(saohan,150,32,fp);                                    // sao.han
     fread(stenam,88,7,fp);                                      // ste.nam
     fclose(fp);
  }

  if(ac>2){
    strcpy(dis,av[1]); strcat(dis," "); strcat(dis,av[2]);
    j=0; for(i=0;i<strlen(dis);i++)if(dis[i]==':')j=1;
    if(j==0){ sscanf(dis,"%lf",&rc); sscanf(av[2],"%lf",&dc); }
    else itohd(dis,&rc,&dc,&z);
    if(ac>3){ sscanf(av[3],"%lf",&w_de); if(w_de<5.)w_de*=60;}
    if(ac<5)goto l10;
// produce CAT directly
    strcpy(f1,av[4]);
    if(ac>5)sscanf(av[5],"%lf",&epoch);
    if(ac>6)sscanf(av[6],"%lf",&obs_epoch);
    icat=1;
    goto l10;
  }
  printf("Input: alpha,delta,epoch  (Ex.3:46:02.11 23:35:47.8 [2000.0])\n");
  gets(dis);
  itohd(dis,&rc,&dc,&z); if(z<1950. || z>2050. )z=2000.0;
  if(z!=2000.0){ astprs2(rc,dc,z,&xa,&xd,2000.0); rc=xa; dc=xd; }

  printf("finding chart epoch [2000.0]\n");
  gets(lab); sscanf(lab,"%lf",&epoch);
  if(epoch<1950. || epoch>2050.) epoch=2000.0;
  astprs2(rc,dc,2000.,&xa,&xd,epoch);
  toms2(xa,c1,1); toms2(xd,c2,0);
  printf("%s --> %s %s (%6.1lf)\n",dis,c1,c2,epoch);

  printf("magnitude limited [18.0]\n");
  gets(dis);  sscanf(dis,"%lf",&xlimag);  if(xlimag<10.)xlimag=10.;
  printf("limited mag: %6.1lf\n",xlimag);
  
  printf("Finding chart size, in arcmin.  [30]\n");
  gets(dis);  sscanf(dis,"%lf",&w_de);
  if(w_de>360.)w_de=360.; if(w_de<10.)w_de=10.;
  printf("Field: %d\n\n",(int)w_de);

l10:
  xxlimag=xlimag;
  if(icat==0){
    printf("\n*********** Help messages ************\n\n");
    printf("  left button  ------  pick a star\n");
    printf("middle button [^c,esc,q]----  quit\n");
    printf(" right button  -------  new center\n");
    printf(" Wheel_up(9), down(3) ----- resize Field\n");
    printf(" Arrow  up(8), down(2), left(4), right(6) ----> move Field\n");
    printf(" keyborad type(C,c) --  save as catalog   (u4.cat)\n");
    printf(" keyborad type(G,g) --  save as fits,GIF  (jfplot.gif)\n");
    printf("\n######################################\n\n");
  }
  while(rc>24.)rc-=24.;     while(rc<0.)rc+=24.;
  if(dc>89.99)dc=89.99;  if(dc<-89.99)dc=-89.99;
  if(w_de<10.)w_de=10.;  if(w_de>360.)w_de=360.;          //field:  10~~360'
  if(w_de>30.){ x=17.-w_de/60.; if(xxlimag>x && ac<8)xxlimag=x;}  // 120'~15m, 240'~13m
// printf("%lf %lf %lf %lf\n",w_de,xlimag,x,xxlimag);
  hw_de=w_de/120.;
  up_d=dc+hw_de;   if(up_d> 90.0)up_d= 90.;
  dn_d=dc-hw_de;   if(dn_d<-90.0)dn_d=-90.;
  x=cos(up_d*cy);   y=cos(dn_d*cy);  z=x; if(z>y)z=y;
  hw_al=hw_de/z/15.;  if(hw_al>12.)hw_al=12.;
  up_a=rc+hw_al;      if(up_a>=24.)up_a-=24.;
  dn_a=rc-hw_al;      if(dn_a<  0.)dn_a+=24.;
  hs=hw_de*cy;   hs2=255./hs;
  a_c=rc*cx;     d_c=dc*cy;
  cosdc=cos(d_c); if(cosdc<.05)cosdc=.05;
// get u4
  nu4=0;
  k1=(dn_d+90.)*5.+1.;  k2=(up_d+90.)*5.+0.9999;
  for(i=k1;i<=k2;i++)cat_u4(i);
  if(w_de>10.)printf("UCAC4_star:%6d\n",nu4);
// get sao
  nsao=0;
  if(isao){
    k1=(dn_d+90.)*0.1+1.;  k2=(up_d+90.)*.1+0.9999;
    cat_sao(k1-1); if(k1!=k2)cat_sao(k1);
    if(w_de>10.)printf("bsc5_ star:%6d\n",nsao);
  }

  n=nu4;                         // total object
  if(n==0){
    printf("#### SORRY, UCAC4 not supply object in this area!!!\7\n");
    if(xxlimag<18.0)printf("May be you choiced field too small !!\n");
  } sort(n);

  xm_max=0.; xm_min=99.;
  for(i=0;i<511;i++)for(j=0;j<511;j++)map[i][j]=0; // project star
  k=35-20*w_de/120; if(k>33)k=33; if(k<15)k=15; j=(33-k)/2;
  for(i=0;i<nu4;i++){            // if star, istar=-1;  galaxy, istar=1
    xmag=ee[i]*0.001; istar=-1; if(objt[i])istar=1; 
    istar=-1;  // force all object is star_type 20120913
    g89(xmag,istar,mx[i],my[i],j);
  }
//sao
  for(i=0;i<nsao;i++) g89((a0sao[i]>>24)*0.1,-1,mxsao[i],mysao[i],j);
//construct bit map end
  for(i=0;i<511;i++)for(j=0;j<511;j++){
    k=map[i][j]; if(k<10)k=10; if(k>255)k=255; cmap[i][j]=255-k;    
  }
  
  if(icat){
    toms2(rc,c1,1); toms2(dc,c2,0);
    sprintf(dis1,"%s %s (%6.1lf) Field:%4d' obs_epoch:%7.1lf",
           c1,c2,epoch,(int)w_de,obs_epoch); 
l222:
    fp0=fopen(f1,"w");
    fprintf(fp0,"#center:%s\n#",dis1);
    for(i=0;i<50;i++)fprintf(fp0,"-"); 
    fprintf(fp0," 6 -- 3 --- 4 --- 5 -- 7 -- B mag. ---- V mag. ----");
    fprintf(fp0," g mag. ---- r mag. ---- i mag. --39\n");
    for(i=0;i<n;i++){
      toms2(aa[i],c1,1);  toms2(dd[i],c2,0);
      xmag=ee[i]*0.001; 
      cc='s'; if(objt[i])cc=objt[i]+48;
      sprintf(dis1,"%5d%s %s (%6.1lf) %010d %c %6.3lf",
                     i+1,c1,c2,epoch,no[i],cc,xmag);
      for(j=41;j<44;j++)dis1[j]=dis1[j+1]; dis1[j]='-';
      fprintf(fp0,"%s",dis1);
      fprintf(fp0,"%7.3f%5.2f%3d",maga[i]*0.001,sigmag[i]*0.01,cdf[i]);
      ap12(&ap1[i],&ap2[i]);
      for(j=0;j<5;j++)fprintf(fp0,"%7.3f%5.2f",api2[j]*0.001,api1[j]*0.01);
      fprintf(fp0,"%3d\n",api1[5]);
    } istar=i+1;
    for(i=0;i<nsao;i++){
      toms2(aasao[i],c1,1);  toms2(ddsao[i],c2,0);
      xmag=(a0sao[i]>>24)*0.1;  k=a0sao[i]&0x3ffff; j=a4sao[i]&0xff; 
      sprintf(dis1,"%5d%s %s (%6.1lf) sao%6d %s%4.1lf v\n",
                     i+istar,c1,c2,epoch,k,spsao[j],xmag);
      fprintf(fp0,"%s",dis1);
    }
    fclose(fp0);
    if(w_de>10.)printf("\n\t%s catalog produced!\n\n",f1); exit(0);
  }

  fp=fopen("u4.tmp","w");
  astprs2(rc,dc,2000.,&xa,&xd,epoch);
  toms2(xa,c1,1); toms2(xd,c2,0);
//    jfbgft(200,235,255,  0,0,0);                   // set BG, front
    jfbegin("",510,510,45);                        // JFBEGIN, "": no file
    jfenv(0.,510.,0.,510.,1);
    if(!isao)jfchina(430.,-18.,q,5);                        // R.A.
    jfdir(2);
    jfchina(-32.,420.,&q[5],5);                    // Decl.
    sprintf(discen,"Center: %s %s (%6.1f)",c1,c2,epoch);
    jftext(-32.,20.,discen);
    if(isao)jftext(525.,240.,"UCAC4 + sao(bsc5)");
    else jftext(525.,240.,"UCAC4");
    jfdir(1);
    jfchina(10.,540.,&q[10],3);                    // north
    jfchina(400.,540.,&q[13],2);                   // field
    jfchina(470.,540.,&q[15],2);                   // arcmin
    jfsci(2);
    sprintf(disfd,"%3d",(int)w_de);
    jftext(439.,539.,disfd);
    jfloadmap(cmap,511,511,0,0,0,0);               // loca map
    jflp(19); jfpoint(255.,255.);                  // center cross
    putcoord(rc,dc,w_de,epoch,obs_epoch);
  sprintf(lab,"%s %s (%6.1lf) %4.1lf~~%4.1lf\\um\\d%6d'",
           c1,c2,epoch,xm_min,xm_max,(int)w_de); k=strlen(lab);
  strcpy(dis,lab);  dis[46]=num=0;
  printf("********** %sm%s\n",dis,&dis[52]);
//****************************************************************
l110:
  jfcursor(&i,&j,&ch);
  jfstext(1); jfsci(0); jftext(320.,539.,disxy);       // continue display
  sprintf(disxy,"%3d %3d",i,j);
  jfsci(4); jftext(320.,539.,disxy); jfstext(-1);
  x=i; y=j; xi=hs-x/hs2;    xn=hs+(y-510.)/hs2;
  astand(a_c,d_c,xi,xn,&xa,&xd);
  toms2(xa/cx,c1,1);  toms2(xd/cy,c2,0);
  jfsci(0); jftext(70.,535.,disrd);
  sprintf(disrd,"%s %s (%6.1f)",c1,c2,epoch);
  jfsci(12); jftext(70.,535.,disrd);
  if(ch=='8'){ xd=w_de/60.; xa=w_de/60./15./cosdc; dc-=xd/50.; goto l111; }
  if(ch=='2'){ xd=w_de/60.; xa=w_de/60./15./cosdc; dc+=xd/50.; goto l111; }
  if(ch=='4'){ xd=w_de/60.; xa=w_de/60./15./cosdc; rc-=xa/50.; goto l111; }
  if(ch=='6'){ xd=w_de/60.; xa=w_de/60./15./cosdc; rc+=xa/50.; goto l111; }
  if(ch==4 || ch=='9'){ if(w_de>=360.)goto l999;
    xd=w_de/60.; xa=w_de/60./15./cosdc; r=w_de*1.05; 
    k=r+0.5; r=k; if(r==w_de)r+=1.; w_de=r;  goto l111;
  }
  if(ch==5 || ch=='3'){ if(w_de==10.)goto l999;
    xd=w_de/60.; xa=w_de/60./15./cosdc; r=w_de/1.05; 
    k=r+0.5; r=k; if(r==w_de)r-=1.; w_de=r;  goto l111;
  }           
  if(ch==1 || ch==3 || ch==13){  r=10000.;            // look cursor distance
    for(i=0;i<nsao;i++){
      rr=(mxsao[i]-x)*(mxsao[i]-x)+(mysao[i]-y)*(mysao[i]-y);
      if(rr<r){ m=i; k1=2; r=rr; }                   // k1=2, select sao
    }
    for(i=0;i<n;i++){
      rr=(mx[i]-x)*(mx[i]-x)+(my[i]-y)*(my[i]-y); if(rr<r){ m=i; k1=1; r=rr; }
    }
  }
  if(ch==3){                                         // new center
    if(r>99.){
      xi=hs-x/hs2;            // accordint cursor position to cal alpha delta
      xn=hs+(y-510.)/hs2;
      astand(a_c,d_c,xi,xn,&xa,&xd);
      rc=xa/cx; dc=xd/cy;
    } else {
      if(k1==1)astprs2(aa[m],dd[m],epoch,&rc,&dc,2000.);
      else astprs2(aasao[m],ddsao[m],epoch,&rc,&dc,2000.);
    }
    goto l111;
  }
  if(ch==1 || ch==13){                               // left button, pick star
    if(r>99.)goto l999;                              // ring only
      jfsci(0);  jftext(0.,-18.,dis);                  // earse bottom
                 jfchina1(400.,-16,dish4,4);
                 jfstext(1); jftext(454.,-16,disao); jfstext(-1);
    if(k1==1){
      x=mx[m]; y=my[m]; num++; sprintf(sc,"%3d",num);
      jfsci(6);  jftext(x-4,y+9,sc);                   // display number
      toms2(aa[m],c1,1);  toms2(dd[m],c2,0);
      xmag=ee[m]*0.001; cc='s'; if(objt[m])cc=objt[m]+48;
      sprintf(dis,"%3d) %s %s (%6.1lf) %010d %c %5.2lfm",
                          num,c1,c2,epoch,no[m],cc,xmag);
      for(i=41;i<44;i++)dis[i]=dis[i+1]; dis[i]='-';
      jfsci(2); jftext(0.,-18.,dis);                   // disply
      printf("%s\n",dis);                              // terminal
      fprintf(fp,"%s %3d %3d\n",dis,mx[m],my[m]);
    } else {
      x=mxsao[m]; y=mysao[m]; num++; sprintf(sc,"%3d",num);
      jfsci(6);  jftext(x-4,y+9,sc);                   // display number
      toms2(aasao[m],c1,1);  toms2(ddsao[m],c2,0);
      xmag=(a0sao[m]>>24)*0.1;  k=a0sao[m]&0x3ffff; j=a4sao[m]&0xff; 
      sprintf(dis,"%3d) %s %s (%6.1lf) sao%6d %s%4.1lf v",
                     num,c1,c2,epoch,k,spsao[j],xmag);
      jfsci(2); jftext(0.,-18.,dis);                   // disply
      printf("%s\n",dis);                              // terminal
      fprintf(fp,"%s %3d %3d\n",dis,mx[m],my[m]);
      i=(a4sao[m]>>24)&0xff;      
      j=(a4sao[m]>>16)&0xff;      
      k=(a4sao[m]>> 8)&0xff;  
      if(j|k){
        for(k2=0;k2<3;k2++)dish4[k2]=stenam[i][k2];  dish4[3]=j;
        sprintf(disao,"   %s",&stenam[i][3]);  
        if(j==0 && k!=0)sprintf(disao,"%2d %s",k,&stenam[i][3]);
        if(j!=0 && k!=0)sprintf(disao," %d %s",k,&stenam[i][3]);
        jfchina1(400.,-16,dish4,4);
        jfstext(1); jftext(454.,-16,disao); jfstext(-1);
      }
    }                                          
    fflush(fp);  goto l110;
  }
  ch&=0x5f;                                          // low -->up_case
  if(ch=='C'){ strcpy(f1,"u4.cat");
    strcpy(dis1,lab); sprintf(&dis1[46],"m Field"); dis1[53]=':';
    goto l222;
  }
  if(ch=='G'){ jfend(2); exit(0); }                  // force produce GIF
  if(ch==2 || ch==27 || ch=='Q' )exit(0);            // ^c,mid,esc,Q for exit
  goto l110;                                         // loop
l999: printf("\7");  fflush(stdout); goto l110;
l111:
// earse edge:
    jfsci(0);
    jftext(0.,-18.,dis);                    // earse bottom
    jftext(70.,535.,disrd);                 // easee up
    jfstext(1);
    jftext(320.,539.,disxy);                // easr X,Y
    jftext(439.,539.,disfd);                // easre Field
    jfchina1(400.,-16,dish4,4);             // easre SAO
    jftext(454.,-16,disao); 
    jfdir(2);
    jftext(-32.,20.,discen);                // earse center
    jfend(0);                               // 0: not destroy grame
    jfsci(1);                               // 1: normal 
    goto l10;                               // 2: force produc GIF, new PIC
}

putcoord(rc,dc,w_de,epoch,obs_epoch)
double rc,dc,w_de,epoch,obs_epoch;
{
  char a[70],c14[14];
  double x,y,z;
  astprs2(rc,dc,2000.,&x,&y,epoch);
  toms2(x,c14,1); sprintf(a,"RA      =        %s /",c14);  jfitskey(8,a);
  toms2(y,c14,0); sprintf(a,"DEC     =         %s /",c14); jfitskey(9,a);
                  sprintf(a,"EPOCH   =%21.1lf /",epoch);  jfitskey(10,a); 
  sprintf(a,"OBS_EPOC=%21.1lf / minus epoch 2000, do Proper Motion Only",
                              obs_epoch);                 jfitskey(11,a);
  z=w_de*60/510; sprintf(a,"SCALE   =%21.4lf /",z);       jfitskey(12,a);
  sprintf(a,"INSTRUME=               JFPLOT /");          jfitskey(13,a); 
  sprintf(a,"CTYPE1  = 'RA---ARC'           /");          jfitskey(15,a);
  sprintf(a,"CTYPE2  = 'DEC--ARC'           /");          jfitskey(16,a);
  sprintf(a,"CROTA2  =                  0.0 /");          jfitskey(17,a);
  sprintf(a,"CRVAL1  =%21.9le /",rc*15);                  jfitskey(18,a);
  sprintf(a,"CRVAL2  =%21.9le /",dc);                     jfitskey(19,a);
  sprintf(a,"CDELT1  =%21.9le /",-z/3600.);               jfitskey(20,a); 
  sprintf(a,"CDELT2  =%21.9le /", z/3600.);               jfitskey(21,a); 
// 256+45  len/2+edge
  sprintf(a,"CRPIX1  =                301.0 /");          jfitskey(22,a);
  sprintf(a,"CRPIX2  =                301.0 /");          jfitskey(23,a);
}

gauss(y,m,sigma)
double y[],sigma;
int m;
{
  int i; double x;
  for(i=0;i<m;i++){
    x=i/sigma; x*=x; if(x>80.)return;
    y[i]=exp(-.5*x);
  }
}

g89(mag,istar,ix,iy,nj1)              // also get min,max_mag
double mag;
short  ix,iy;
int    istar,nj1;
{
  double y[33],x,xmag,w,high,sigma,rr,r;
  short  a[33][33];
  int    i,j,k,ii,jj,nj2,kr;

  nj2=32-nj1;  xmag=mag;  w=w_de;
  if(w>120.){ xmag+=4.; w/=4; }             // xmag changed
  for(i=0;i<33;i++)y[i]=0;
  high=16.; x=60./w+15.-xmag;
  if(w<=8.)x=60./w+(15.-xmag)*2.;
  if(istar==-1){                            // for star ***********
    if(xmag<6.)x=((6.-xmag)*0.3+1.)*x;
    sigma=.5+x*.25; gauss(y,33,sigma);
    rr=(sigma*0.5+0.5)/sqrt(40./w); if(rr<1.)rr=1.;
    for(j=nj1;j<17;j++){
      jj=(j-16); jj*=jj;
      for(i=nj1;i<17;i++){
        r=jj+(i-16)*(i-16);
        kr=sqrt(r)+0.5; r=y[kr]*high+0.5;
        if(j==16 || i==16)r*=rr;
        a[i][j]= a[i][32-j]= a[32-i][j]= a[32-i][32-j]=r*16.;
      }
    }
  } else {                                   // for galaxy ***********
    high=10.;
    sigma=1.+x*.2; gauss(y,33,sigma);
    for(j=nj1;j<17;j++){
      jj=(j-16); jj*=jj;
      for(i=nj1;i<=nj2;i++){
        r=jj+(i-16)*(i-16)+(i-16)*(16-j);
        kr=sqrt(r)+0.5; r=y[kr]*high;
        if(r>0.5 && r<1.)r=1.; if(r>9.)r=9.;
        a[i][j]= a[32-i][32-j]=r*16.;
      }
    }
  }
  if(mag>xm_max)xm_max=mag; if(mag<xm_min)xm_min=mag;
  w=(nj2+nj1)*0.5;
  rr=(nj2-nj1)*(nj2-nj1)*0.25;
  for(j=nj1;j<=nj2;j++){
    jj=iy-16+j; if(jj<0 || jj>510)continue;
    for(k=nj1;k<=nj2;k++){
      r=(k-w)*(k-w)+(j-w)*(j-w); if(r>rr)continue;
      ii=ix-16+k; if(ii>=0 && ii <511)
      if(map[jj][ii]<a[k][j])map[jj][ii]=a[k][j];
    }
  }
}

i_star(ra,dc,ix,iy)
double ra,dc; short *ix,*iy;
{
  double xa,xd,xi,xn;
  xa=ra*cx; xd=dc*cy;
  standc(a_c,d_c,xa,xd,&xi,&xn);
  *ix=hs2*(hs-xi)+.5;
  *iy=hs2*(xn-hs)+510.5;
  if(*ix < 0 || *ix >510)return(0);
  if(*iy < 0 || *iy >510)return(0);
  return(1);
}

#pragma pack(1)
struct {
 int   ra,dc; short magm,maga; char  sigmag,objt,cdf;   // 15 
 char  s5[5];                                           //  5 
 short cepra,cepdc; short pr2, pd2; char  s2[2];        // 10
 int a1; short j_m,h_m,k_m; char icqflg[3],e2mpho[3];   // 16
// short apasm[5]; char apase[5],gcflg;                        // 16
 double ap1,ap2;                                        // 16
 int icf; char leda,x2m; int  rnm; short zn2; int  rn2; // 16
} u;
cat_u4(i360)
int i360;
{
  double x1,x2, ra,dc,mas,xa,xd,xmag;
  short  ix,iy;
  char   f1[30];
  int    i,j,k,i87;

  mas=3600000.;    i=i360-1;
  x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=x1*10.; j--; if(j<0)k=0; else  k=u4index[j][i];
  i87=0; if(up_d>87. || dn_d<-87.){ i87=1;  k=0; }
  sprintf(f1,"/UCAC4/z%03d\0",i360);

  fp=fopen(f1,"rb");
  if(fp==0){ printf("datafile not found! %s\n",f1); exit(0); }
l05:
  fseek(fp,k*78,0);
l10:
  fread(&u,1,78,fp);   if(feof(fp))goto l20;
  k++;
  ra=u.ra/mas/15.;
  if(ra>x2 && i87==0)goto l100;               // normal exit
  if(ra<x1 && i87==0)goto l10;
  dc=(u.dc-mas*90.)/mas;  if(dc<dn_d || dc>up_d)goto l10;
  xmag=u.magm*.001;  // if(xmag<0.)xmag=-xmag;  
                               if(xmag > xxlimag)goto l10;
  if(i_star(ra,dc,&ix,&iy)){
    if(epoch!=2000.0){
      astprs2(ra,dc,2000.0,&xa,&xd,epoch);
      ra =xa+u.pr2*.1*(epoch-2000.0)/mas/15./cosdc;
      dc=xd+u.pd2*.1*(epoch-2000.0)/mas;
    }
    if(obs_epoch!=epoch){          // for cat, SM correct
      ra+=u.pr2*.1*(obs_epoch-epoch)/mas/15./cosdc;
      dc+=u.pd2*.1*(obs_epoch-epoch)/mas;
    }
    aa[nu4]=ra;
    dd[nu4]=dc;
    ee[nu4]=u.magm;    
    no[nu4]=i360*1000000+k;
//    no[nu4]=u.rnm;
    mx[nu4]=ix;
    my[nu4]=iy;

    maga[nu4]=u.maga;
  sigmag[nu4]=u.sigmag;
    objt[nu4]=u.objt;
     cdf[nu4]=u.cdf;
     ap1[nu4]=u.ap1;
     ap2[nu4]=u.ap2;

    nu4++; if(nu4==nn)nu4--;
  }
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=0;
  if(i87==0)goto l05;
l100:
  fclose(fp);
}

cat_sao(int k1)
{
  double x1,x2, ra,dc,mas,xa,xd;
  short  ix,iy,pra,pde;
  int    a5[5],i,j,k,i87;
float mag;
  mas=3600000.;   x1=dn_a; x2=up_a;  if(x2<x1)x2+=24.;
  j=x1/6.; j--; if(j<0)k=insao[k1][0]; else  k=insao[k1][j];
  i87=0;  if(up_d>87. || dn_d<-87.){ i87=1;  k=insao[k1][0]; }
l10:
  if(k>=insao[k1][6]) goto l20;
  for(i=0;i<5;i++)a5[i]=dasao[k][i]; k++;
// only keep BSC5_star
  if((a5[4]&0xffffff00)==0)goto l10;  
  ra=a5[1]/mas/15.;
  if(ra>x2 && i87==0)return;
  if(ra<x1 && i87==0)goto l10;
  dc=(a5[2]-mas*90.)/mas;  if(dc<dn_d || dc>up_d)goto l10;
  pra=a5[3]>>16; pde=a5[3]&0xffff;
  if(i_star(ra,dc,&ix,&iy)){
    if(epoch!=2000.0){          // pra=?*10000; pde=?*1000;
      astprs2(ra,dc,2000.0,&xa,&xd,epoch);  //mas=3600.*1000.
      ra =xa+pra*.1*(epoch-2000.0)/mas;
      dc =xd+pde   *(epoch-2000.0)/mas;
    }
    if(obs_epoch!=epoch){          // for cat, SM correct
      ra+=pra*.1*(obs_epoch-epoch)/mas;
      dc+=pde   *(obs_epoch-epoch)/mas;
    }
    aasao[nsao]=ra;
    ddsao[nsao]=dc;
    a0sao[nsao]=a5[0];   
    a4sao[nsao]=a5[4];
    mxsao[nsao]=ix;
    mysao[nsao]=iy;
    nsao++; if(nsao==mm)nsao--;
  }
  goto l10;
l20:
  x1-=24.; x2-=24.;  k=insao[k1][0];
  if(i87==0)goto l10;
}

sort(int n)
{
  int i,j;
  double d8; int i4; short i2; char i1;
  for(i=0;i<n-1;i++)for(j=i+1;j<n;j++)if(dd[i]>dd[j]){
    d8=aa[i]; aa[i]=aa[j]; aa[j]=d8;
    d8=dd[i]; dd[i]=dd[j]; dd[j]=d8;
    i4=no[i]; no[i]=no[j]; no[j]=i4;
    i2=ee[i]; ee[i]=ee[j]; ee[j]=i2;
    i2=mx[i]; mx[i]=mx[j]; mx[j]=i2;
    i2=my[i]; my[i]=my[j]; my[j]=i2;

    i2=maga[i]; maga[i]=maga[j]; maga[j]=i2;
    i1=sigmag[i]; sigmag[i]=sigmag[j]; sigmag[j]=i1;
    i1=objt[i]; objt[i]=objt[j]; objt[j]=i1;
    i1=cdf[i]; cdf[i]=cdf[j]; cdf[j]=i1;
    d8=ap1[i]; ap1[i]=ap1[j]; ap1[j]=d8;
  }
}

ap12(d1,d2)
unsigned short *d1; unsigned char *d2; 
{
  int i;
  for(i=0;i<4;i++)api2[i]=d1[i];
  api2[4]=d2[1]*256+d2[0];
  for(i=0;i<6;i++)api1[i]=d2[i+2];
}
/*
col byte item   fmt unit       explanation                            notes
---------------------------------------------------------------------------
 1  1- 3 ra     I*4 mas        right ascension at  epoch J2000.0 (ICRS) (1)
 2  5- 8 spd    I*4 mas        south pole distance epoch J2000.0 (ICRS) (1)
 3  9-10 magm   I*2 millimag   UCAC fit model magnitude                 (2)
 4 11-12 maga   I*2 millimag   UCAC aperture  magnitude                 (2)
 5 13    sigmag I*1 1/100 mag  error of UCAC magnitude                  (3)
 6 14    objt   I*1            object type                              (4)
 7 15    cdf    I*1            combined double star flag                (5)
         15 bytes
 8 16    sigra  I*1 mas        s.e. at central epoch in RA (*cos Dec)   (6)
 9 17    sigdc  I*1 mas        s.e. at central epoch in Dec             (6)
10 18    na1    I*1            total # of CCD images of this star
11 19    nu1    I*1            # of CCD images used for this star       (7)
12 20    cu1    I*1            # catalogs (epochs) used for proper motions
          5 bytes
13 21-22 cepra  I*2 0.01 yr    central epoch for mean RA, minus 1900
14 23-24 cepdc  I*2 0.01 yr    central epoch for mean Dec,minus 1900
15 25-26 pmrac  I*2 0.1 mas/yr proper motion in RA*cos(Dec)             (8)
16 27-28 pmdc   I*2 0.1 mas/yr proper motion in Dec
17 29    sigpmr I*1 0.1 mas/yr s.e. of pmRA * cos Dec                   (9)
18 30    sigpmd I*1 0.1 mas/yr s.e. of pmDec                            (9)
         10 bytes
19 31-34 pts_key I*4           2MASS unique star identifier            (10)
20 35-36 j_m    I*2 millimag   2MASS J  magnitude
21 37-38 h_m    I*2 millimag   2MASS H  magnitude
22 39-40 k_m    I*2 millimag   2MASS K_s magnitude
23 41    icqflg I*1            2MASS cc_flg*10 + ph_qual flag for J    (11)
24 42     (2)   I*1            2MASS cc_flg*10 + ph_qual flag for H    (11)
25 43     (3)   I*1            2MASS cc_flg*10 + ph_qual flag for K_s  (11)
26 44    e2mpho I*1 1/100 mag  error 2MASS J   magnitude               (12)
27 45     (2)   I*1 1/100 mag  error 2MASS H   magnitude               (12)
28 46     (3)   I*1 1/100 mag  error 2MASS K_s magnitude               (12)
         16 bytes
29 47-48 apasm  I*2 millimag   B magnitude from APASS                  (13)
30 49-50  (2)   I*2 millimag   V magnitude from APASS                  (13)
31 51-52  (3)   I*2 millimag   g magnitude from APASS                  (13)
32 53-54  (4)   I*2 millimag   r magnitude from APASS                  (13)
33 55-56  (5)   I*2 millimag   i magnitude from APASS                  (13)
34 57    apase  I*1 1/100 mag  error of B magnitude from APASS         (14)
35 58     (2)   I*1 1/100 mag  error of V magnitude from APASS         (14)
36 59     (3)   I*1 1/100 mag  error of g magnitude from APASS         (14)
37 60     (4)   I*1 1/100 mag  error of r magnitude from APASS         (14)
38 61     (5)   I*1 1/100 mag  error of i magnitude from APASS         (14)
39 62    gcflg  I*1            Yale SPM g-flag*10  c-flag              (15)
         16 bytes
40 63-66 icf(1) I*4            FK6-Hipparcos-Tycho source flag         (16)
41       icf(2) ..             AC2000       catalog match flag         (17)
42       icf(3) ..             AGK2 Bonn    catalog match flag         (17)
43       icf(4) ..             AKG2 Hamburg catalog match flag         (17)
44       icf(5) ..             Zone Astrog. catalog match flag         (17)
45       icf(6) ..             Black Birch  catalog match flag         (17)
46       icf(7) ..             Lick Astrog. catalog match flag         (17)
47       icf(8) ..             NPM  Lick    catalog match flag         (17)
48       icf(9) ..             SPM  YSJ1    catalog match flag         (17)
          4 bytes
49 67    leda   I*1            LEDA galaxy match flag                  (18)
50 68    x2m    I*1            2MASS extend.source flag                (19)
51 69-72 rnm    I*4            unique star identification number       (20)
52 73-74 zn2    I*2            zone number of UCAC2 (0 = no match)     (21)
53 75-78 rn2    I*4            running record number along UCAC2 zone  (21)
         12 bytes
---------------------------------------------------------------------------
         78 = total number of bytes per star record
*/
